<template>
    <div class="notebook-header">
        <notebook-placeholder
            :notebook="notebook"
            :active="isActive(notebook)"
            v-for="(notebook, index) in allNotebooks"
            :key="index"
            @selected="passOnSelected"
        ></notebook-placeholder>
        <notebook-options :notebook="currentNotebook"></notebook-options>
    </div>
</template>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import { Prop } from 'vue-property-decorator'
import { State } from 'vuex-class'
import NotebookPlaceholder from '@/app/Editor/components/primitives/NotebookPlaceholder.vue'
import NotebookOptions from './NotebookOptions.vue'
import { offlineDB } from '@/offline/db'
import { INotebook, INote } from '@/store/types/notebooks'
import { IRoot } from '@/store/types/root'

@Component({
    components: { NotebookPlaceholder, NotebookOptions },
})
export default class NotebookHeader extends Vue {
    // Lifecycle

    // Props

    @Prop() currentNotebook: INotebook | undefined

    // Data

    @State((state: IRoot) => {
        if (!state.Notebooks) return []
        return state.Notebooks.notebooks
    })
    allNotebooks: INotebook[] | undefined

    // Methods

    isActive(notenook: INotebook) {
        if (this.currentNotebook) {
            return this.currentNotebook.id === notenook.id
        }
        return false
    }

    passOnSelected(notebook: INotebook) {
        offlineDB.saveCurrentNotebook(notebook)
    }
}
</script>